/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.security.flow.business.feign;

import lombok.AllArgsConstructor;
import org.flowable.engine.*;
import org.flowable.engine.runtime.ProcessInstance;
import org.security.flow.business.service.FlowBusinessService;
import org.security.flow.core.constant.ProcessConstant;
import org.security.flow.core.entity.BladeFlow;
import org.security.flow.core.entity.BladeFlowDef;
import org.security.flow.core.feign.IFlowClient;
import org.security.flow.core.utils.TaskUtil;
import org.springblade.core.tenant.annotation.NonDS;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.support.Kv;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;
import org.flowable.engine.repository.ProcessDefinitionQuery;
import org.flowable.engine.repository.ProcessDefinition;

import java.util.Map;

/**
 * 流程远程调用实现类
 *
 * @author Chill
 */
@NonDS
@RestController
@AllArgsConstructor
public class FlowClient implements IFlowClient {

	private final RuntimeService runtimeService;
	private final IdentityService identityService;
	private final TaskService taskService;
	private final RepositoryService repositoryService;
	private final FlowBusinessService businessService;

	@Override
	@PostMapping(START_PROCESS_INSTANCE_BY_ID)
	public R<BladeFlow> startProcessInstanceById(String processDefinitionId, String businessKey, @RequestBody Map<String, Object> variables) {
		String authenticatedUserId;
		if (variables.containsKey(ProcessConstant.START_PROC_USER_ID)) {
			authenticatedUserId = TaskUtil.getTaskUser(String.valueOf(variables.get(ProcessConstant.START_PROC_USER_ID)));
		} else {
			authenticatedUserId = TaskUtil.getTaskUser();
		}
		// 设置流程启动用户
		identityService.setAuthenticatedUserId(authenticatedUserId);
		// 开启流程
		ProcessInstance processInstance = runtimeService.startProcessInstanceById(processDefinitionId, businessKey, variables);
		// 组装流程通用类
		BladeFlow flow = new BladeFlow();
		flow.setProcessInstanceId(processInstance.getId());
		return R.data(flow);
	}

	@Override
	@PostMapping(START_PROCESS_INSTANCE_BY_KEY)
	public R<BladeFlow> startProcessInstanceByKey(String processDefinitionKey, String businessKey, @RequestBody Map<String, Object> variables) {
		// 设置流程启动用户
		identityService.setAuthenticatedUserId(TaskUtil.getTaskUser());
		// 开启流程
		ProcessInstance processInstance = runtimeService.startProcessInstanceByKey(processDefinitionKey, businessKey, variables);
		// 组装流程通用类
		BladeFlow flow = new BladeFlow();
		flow.setProcessInstanceId(processInstance.getId());
		return R.data(flow);
	}

	@Override
	@PostMapping(COMPLETE_TASK)
	public R completeTask(String taskId, String processInstanceId, String comment, @RequestBody Map<String, Object> variables) {
		// 增加评论
		if (StringUtil.isNoneBlank(processInstanceId, comment)) {
			taskService.addComment(taskId, processInstanceId, comment);
		}
		// 非空判断
		if (Func.isEmpty(variables)) {
			variables = Kv.create();
		}
		// 完成任务
		taskService.complete(taskId, variables);
		return R.success("流程提交成功");
	}

	@Override
	@GetMapping(TASK_VARIABLE)
	public R<Object> taskVariable(String taskId, String variableName) {
		return R.data(taskService.getVariable(taskId, variableName));
	}

	@Override
	@GetMapping(TASK_VARIABLES)
	public R<Map<String, Object>> taskVariables(String taskId) {
		return R.data(taskService.getVariables(taskId));
	}

	@Override
	@GetMapping(PROCESS_DEFINITION)
	public R<BladeFlowDef> getLatestProcessDefinitionByKey(String processDefinitionKey) {
		ProcessDefinitionQuery processDefinitionQuery = repositoryService.createProcessDefinitionQuery()
			.processDefinitionWithoutTenantId().processDefinitionKey(processDefinitionKey).latestVersion();
		ProcessDefinition processDefinition = processDefinitionQuery.singleResult();
		return R.data(buildFlowDefinition(processDefinition));
	}

	@Override
	@GetMapping(DELETE_RPOC_INS)
	public R deleteProcessInstanceByInstanceId(String processInstanceIds) {
		return businessService.deleteProcessInstance(processInstanceIds);
	}

	private BladeFlowDef buildFlowDefinition(ProcessDefinition processDef) {
		BladeFlowDef def = new BladeFlowDef();
		def.setCategory(processDef.getCategory());
		def.setDeploymentId(processDef.getDeploymentId());
		def.setDerivedForm(processDef.getDerivedFrom());
		def.setDerivedFromRoot(processDef.getDerivedFromRoot());
		def.setDerivedVersion(processDef.getDerivedVersion());
		def.setDescription(processDef.getDescription());
		def.setDiagramResourceName(processDef.getDiagramResourceName());
		def.setEngineVersion(processDef.getEngineVersion());
		def.setHasGraphicalNotation(processDef.hasGraphicalNotation());
		def.setHasStartFormKey(processDef.hasStartFormKey());
		def.setId(processDef.getId());
		def.setKey(processDef.getKey());
		def.setName(processDef.getName());
		def.setResourceName(processDef.getResourceName());
		def.setSuspended(processDef.isSuspended());
		def.setTenantId(processDef.getTenantId());
		def.setVersion(processDef.getVersion());
		return def;
	}

}
